# **DD**, dump et debug de base

Ajoute un filtre `dd` utilisable dans les squelettes : `[(#GET{patate}|dd)]`.  
On peut aussi dumper tout l'#ENV avec `#ENVDD`.

Ajoute des fonctions `debug()`, `d()` et `debug_sql()` utilisables en PHP qui génèrent des dumps avec un habillage très lisible.

Affiche une boite d'infos (privé et public) en bas de la page : nombre de requêtes Mysql exécutées, temps d'exécution de la page, mémoire utilisée, charge serveur (load) sur les pages html.  
Ces infos sont loggées lors des appels ajax, ce qui permet de vérifier le nombre de requetes SQL générées par un calcul ajax.

Ces infos sont affichées uniquement pour les webmestres.   
On peut aussi définir une IP (avec la constante `DD_INFOS_IP`) depuis laquelle ces infos seront toujours affichées (pour tester un site sans être connecté, par exemple).

Si `DD_INFOS_IP` est définie, elle permet aussi de lancer un `var_profile` sans être connecté (surcharge de autoriser_debug)

Pour pouvoir afficher la liste de toutes les requetes SQL exécutées en cliquant sur le total affiché, modifier le fichier `/ecrire/req/mysql` vers la ligne 250 :

```
	$start_query_time = microtime(true);
	$r = mysqli_query($link, $query . $debug);
	$connexion['requetes'][] = array('sql' => $query, 'time' => microtime(true) - $start_query_time);
```